Function strcoord, rastri, decstri, delimiteri
  ;Prend en entree des coordonnes du genre '00 05 12.4', '+36 18 13' et retourne un vecteur contenant RA et DEC en DEGRÉS
  ;Se fait toujours en double précision
  ;delimiter = ':' permet d'avoir par exemple '00:05:12.4', '+36:18:13'
  ;delimiter = 'NONE' permet de prendre les chiffres deux a deux
  
  on_error, 2
  forward_function sign
  
  rastr = rastri
  if keyword_set(decstri) then $
    decstr = decstri
  ;On enlève les barres ascii bizarres
  if ~keyword_set(delimiteri) then delimiteri = ' '
  if max(strpos(rastr,string(150b))) ne -1 then $
    message, 'String contains badly formatted - sign !'
    ;strreplace, rastr, string(150b), '-'
  if keyword_set(decstr) then $
    if max(strpos(decstr,string(150b))) ne -1 then $
      message, 'String contains badly formatted - sign !'
      ;strreplace, decstr, string(150b), '-'
  delimiter = delimiteri
  
  if ~keyword_set(decstr) and keyword_set(rastr) then begin
    coords = rastr
    strkill, coords, '2MASS J'
    strkill, coords, 'SIMP J'
    strkill, coords, 'SIMPJ'
    strkill, coords, 'SDSS J'
    strkill, coords, '2MASS'
    strkill, coords, '2M'
    strkill, coords, 'J'
    strkill, coords, '.'
    spos = strpos(coords,'-')>strpos(coords,'+')
    rastr = strmid(coords,0,2)+':'+strmid(coords,2,2)+':'+strmid_arr(coords,4,2);spos-6
    more = where(spos gt 6, nmore)
    if nmore ne 0 then rastr[more] += '.'+strmid_arr(coords[more],6,spos[more]-6)
    decstr = strmid_arr(coords,spos+1,2)+':'+strmid_arr(coords,spos+3,2)+':'+strmid_arr(coords,spos+5,2)
    more = where(strlen(coords) - spos gt 7, nmore)
    if nmore ne 0 then decstr[more] += '.'+strmid_arr(coords[more],spos+7)
    decstr = strmid_arr(coords,spos,1)+decstr
    delimiter = ':'
  endif
  
  ;Version array
  if n_elements(rastr) gt 1 then begin
    if n_elements(decstr) eq 1 then decstr = replicate(decstr,n_elements(rastr))
    coordarr = dindgen(n_elements(rastr),2)
    for i=0, n_elements(rastr)-1 do $
      coordarr[i,*] = strcoord(rastr[i], decstr[i], delimiter)
    return, coordarr
  endif
  
  conversion = [1d0,1d0/60., 1d0/3600.]
  if ~keyword_set(delimiter) then delimiter = ' '
  
  ;Cas sans delimiter
  if strlowcase(delimiter) eq 'none' then begin
    ;Cas avec rastr et decstr joints ensemble
    if decstr eq '' then begin
      sepp = strpos(rastr,'+')>strpos(rastr,'-')
      if sepp eq -1 then message, ' On ne trouve pas de symbole + ou - !'
      decstr = strmid(rastr,sepp)
      rastr = strmid(rastr,0,sepp)
    endif
    
    rastr = strmid(rastr,0,2)+':'+strmid(rastr,2,2)+':'+strmid(rastr,4)
    fc = strmid(decstr,0,1)
    if fc ne '-' and fc ne '+' then begin
      decstr = '+'+decstr
      fc = '+'
    endif
    decstr = fc+strmid(decstr,1,2)+':'+strmid(decstr,3,2)+':'+strmid(decstr,5)
    delimiter = ':'
    if strlen(rastr) gt 6 then rastr = strmid(rastr,0,8)+'.'+strmid(rastr,8)
    if strlen(decstr) gt 7 then decstr = strmid(decstr,0,9)+'.'+strmid(decstr,9)
  endif
  
  ra = total(strsplit(rastr, delimiter, /extract)*conversion)*15
  decsp = strsplit(decstr, delimiter, /extract)
  fd = strmid(decsp[0],0,1)
  if fd eq '-' then sgn = -1 else sgn = 1
  dec = sgn*total(abs(float(decsp)*conversion))
  
  return, [ra, dec]
End